property debug_me : true

property script_author : "Jonathan Nathan"
property script_name : "full_disclosure"
property script_version : "1.0.1"
property script_release_date : "January 31, 2007"
property script_copyright : " 2004, 2007 Jonathan Nathan. All Rights Reserved."

property script_url : "http://www.jonn8.com/"
property script_email : "mailto:Jonathan%20Nathan%20%3Cjonn8%40mac.com%3E?subject=Re:full_disclosure%20(v" & script_version & ")"

property first_run : true

on will finish launching the_object
	set object_name to name of the_object as Unicode text
	my update_status("will finish launching " & object_name)
	my register_settings()
	my read_settings()
end will finish launching

on launched the_object
	my update_status("launched " & (name of the_object as Unicode text))
	activate
	show window "main"
	if first_run then display window "license" attached to window "main"
end launched

on should quit after last window closed the_object
	return true
end should quit after last window closed

on awake from nib the_object
	set object_name to name of the_object as Unicode text
	my update_status("awake from nib " & object_name)
	if object_name = "main" then
		tell the_object
			if first_run then center
		end tell
		
	else if object_name = "about" then
		tell the_object
			tell box 1
				set contents of text field "title" to (script_name & " v" & script_version)
				set contents of text field "author" to ("by " & script_author)
				set contents of text field "release" to ("Released " & script_release_date)
				set contents of text field "copyright" to (script_copyright)
			end tell
		end tell
		
	end if
end awake from nib

on activated the_object
	set object_name to name of the_object as Unicode text
	my update_status("activated " & object_name)
end activated

on choose menu item the_object
	set object_name to name of the_object as Unicode text
	my update_status("choose menu item " & object_name)
	
	if object_name = "about" then
		display window "about" attached to window "main"
		
	else if object_name = "quit" then
		quit
		
	end if
end choose menu item

on clicked the_object
	set object_name to name of the_object as Unicode text
	my update_status("clicked " & object_name)
	
	if object_name = "decline" then
		close panel window "license"
		quit
		
	else if object_name = "accept" then
		set first_run to false
		my write_settings()
		close panel window "license"
		
	else if object_name = "dialog_cancel" then
		set the_win to name of window of the_object
		close panel window the_win
		
	else if object_name = "dialog_ok" then
		set the_win to name of window of the_object
		close panel window the_win
		
	else if object_name = "stop_progress" then
		set my stop_progress to false
		
	else if object_name = "about_webpage" then
		open location script_url
		
	else if object_name = "about_email" then
		open location script_email
		
	else if object_name = "disclosure" then
		if state of the_object = 0 then
			set the_delta to 200
		else
			set the_delta to -200
		end if
		tell window of the_object
			set {x1, y1, x2, y2} to bounds
			set bounds to {x1, (y1 + the_delta), x2, y2}
		end tell
		
	end if
end clicked

on action the_object
	set object_name to name of the_object as Unicode text
	my update_status("action " & object_name)
end action

on will open the_object
	try
		set {x, y} to (get size of window "main")
		set size of the_object to {x, y - 22}
	end try
	return true
end will open

on will quit the_object
	my quit_prep()
	return true
end will quit

on idle the_object
	return 1
end idle

on quit_prep()
	set panel_wins to name of (windows whose class = panel and visible = true)
	repeat with i from 1 to (length of panel_wins)
		try
			close panel window (item i of panel_wins)
		end try
	end repeat
	my write_settings()
	set quitting to true
end quit_prep

on display_error(the_title, the_error)
	activate
	beep
	my update_status("Error: " & the_error)
	display alert the_title as critical message the_error default button "OK" attached to window "main"
end display_error

on register_settings()
	my update_status("registering settings...")
	tell user defaults
		make new default entry at end of default entries with properties {name:"first_run", contents:first_run}
		register
	end tell
	my update_status("settings registered")
end register_settings

on read_settings()
	my update_status("reading settings...")
	tell user defaults
		set first_run to contents of default entry "first_run"
	end tell
	my update_status("settings read")
end read_settings

on write_settings()
	my update_status("writing settings...")
	tell user defaults
		set contents of default entry "first_run" to first_run
	end tell
	my update_status("settings written")
end write_settings

on update_status(the_message)
	if debug_me then log the_message
end update_status
